#!/usr/bin/env python
import syslog, ConfigParser
syslog.syslog("servercgi [INFO] Importation Module HTTP")
from BaseHTTPServer import HTTPServer
syslog.syslog("servercgi [INFO] Importation Module CGI")
from CGIHTTPServer import CGIHTTPRequestHandler
syslog.syslog("servercgi [INFO] Importation Module OS")
import os

class MyCGIHTTPRequestHandler(CGIHTTPRequestHandler):

    def log_message(self, format, *args):
	syslog.syslog("servercgi [INFO] %s" % (format%args))

    def log_error(self, format, *args):
	syslog.syslog("servercgi [ERROR] %s" % (format%args))

try:
	syslog.syslog("servercgi [INFO] read configuration")
	config = ConfigParser.ConfigParser()
	config.read('base.conf')

	CONF_BASE = config.get('Server', 'Base')
	CONF_CGI = config.get('Server', 'Cgi')
	if CONF_CGI == 'None': CONF_CGI = None
	CONF_PORT = config.getint('Server', 'Port')
	CONF_TIMEOUT = config.getint('Server', 'Timeout')
	syslog.syslog("servercgi [INFO] test port")

	import socket
	s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
	s.settimeout(CONF_TIMEOUT)
	code=s.connect_ex(("127.0.0.1",CONF_PORT))
	if code == 0:
		syslog.syslog("servercgi [WARNING] Port is already use !!!")
		syslog.syslog("servercgi [ERROR] Server down")
	else:
		syslog.syslog("servercgi [INFO] Server up")
		os.chdir(CONF_BASE)
		if CONF_CGI <> None:
			syslog.syslog("servercgi [INFO] directory for cgi %s" % CONF_CGI)
			MyCGIHTTPRequestHandler.cgi_directories = ['%s' % CONF_CGI]
		serv = HTTPServer( ("", CONF_PORT), MyCGIHTTPRequestHandler)
		serv.serve_forever()
except Exception, err:
	syslog.syslog("servercgi [ERROR] %s" % err)
	syslog.syslog("servercgi [ERROR] Server down")
	










